package com.usoft.sso.rest.domain.config;

import com.usoft.sso.grpc.api.protobuf.SSOGrpcServiceGrpc;
import io.grpc.CallOptions;
import io.grpc.ManagedChannel;
import io.grpc.ManagedChannelBuilder;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * sso GRPC Client 连接配置
 *
 * @author: wangcanyi
 * @date: 2018-07-31 17:57
 */
@Configuration
public class SSOGrpcConfig {

	/**
	 * 接口连接超时时间,单位毫秒
	 */
	public final static CallOptions.Key<Integer> CO_KEY_CONNECTION_TIMEOUT = CallOptions.Key.of("COKey_ConnectionTimeout", 0);
	@Value("${sso.grpc.host}")
	private String ssoGrpcHost;
	@Value("${sso.grpc.port}")
	private int ssoGrpcPort;

	@Bean(name = "ssoManagedChannel")
	public ManagedChannel getSsoManagedChannel() {
		return ManagedChannelBuilder.forAddress(ssoGrpcHost, ssoGrpcPort).usePlaintext().build();
	}


	@Bean(name = "ssoUserSBS")
	public SSOGrpcServiceGrpc.SSOGrpcServiceBlockingStub getSsoEGUserServiceBlockingStub(ManagedChannel managedChannel) {
		SSOGrpcServiceGrpc.SSOGrpcServiceBlockingStub UserServiceBlockingStub =
				SSOGrpcServiceGrpc.newBlockingStub(managedChannel).withOption(CO_KEY_CONNECTION_TIMEOUT, 5000);
		return UserServiceBlockingStub;
	}

	@Bean(name = "SSOUserSFS")
	public SSOGrpcServiceGrpc.SSOGrpcServiceBlockingStub getSsoEGUserServiceFutureStub(ManagedChannel managedChannel) {
		SSOGrpcServiceGrpc.SSOGrpcServiceBlockingStub UserServiceBlockingStub =
				SSOGrpcServiceGrpc.newBlockingStub(managedChannel).withOption(CO_KEY_CONNECTION_TIMEOUT, 5000);
		return UserServiceBlockingStub;
	}
}
